diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
index 90b8e3f2d..0daf8646d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.dynamictexture;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 
 public class DynamicTextureClock extends DynamicTextureAbstractClock{
 
@@ -16,7 +17,7 @@ public class DynamicTextureClock extends DynamicTextureAbstractClock{
 		if(mc.currentWorld != null && mc.thePlayer != null) {
 			float f = mc.currentWorld.getCelestialAngle(1.0f);
 			d = -f * Math.PI * 2;
-			if(mc.currentWorld.dimension == Dimension.NETHER) {
+			if(mc.currentWorld.getWorldType().hasTag(WorldTypeTags.BREAKS_TIMEPIECES)) {
 				d = Math.random() * Math.PI * 2;
 			}
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index 8342a41c7..9fcc0fcd9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -9,6 +9,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 
 public class DynamicTextureCompass extends DynamicTexture {
 	
@@ -71,7 +72,7 @@ public class DynamicTextureCompass extends DynamicTexture {
 			double dx = (double)spawnPoint.x - this.mc.thePlayer.x;
 			double dz = (double)spawnPoint.z - this.mc.thePlayer.z;
 			angle = (double)(this.mc.thePlayer.yRot - 90.0F) * PI / 180.0D - Math.atan2(dz, dx);
-			if(this.mc.currentWorld.dimension == Dimension.NETHER) {
+			if(this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.BREAKS_COMPASS)) {
 				angle = Math.random() * PI * 2;
 			}
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index 037cce9b5..b1ad7dc4d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -4,7 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 public class DynamicTextureWaterFlow extends DynamicTexture {
@@ -69,14 +69,7 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 
 		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
 			float pow = this.current[pmod(i - this.ticks * this.targetTexture.width, this.targetTexture.getArea())];
-			if (pow > 1.0F) {
-				pow = 1.0F;
-			}
-
-			if (pow < 0.0F) {
-				pow = 0.0F;
-			}
-
+			pow = MathHelper.clamp(pow, 0.0f, 1.0f);
 			float pp = pow * pow;
 
 			int r = (int) (32.0F + pp * 32.0F);
@@ -84,11 +77,15 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + pp * 50.0F);
 
-			if (this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
-				r = 255;
-				g = (int) (110.0F + pp * 64.0F);
-				b = (int) (32.0F + pp * 32.0F);
+			if (this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
 				a = (int) (225.0F + pp * 50.0F);
+
+				if (!GameSettings.BIOME_WATER.value) {
+					final float br = 0.3F;
+					r = (int) (255.0F * br);
+					g = (int) ((50.0F + pp * 64.0F) * br);
+					b = (int) ((32.0F + pp * 32.0F) * br);
+				}
 			}
 
 			r = MathHelper.clamp(r, 0, 255);
@@ -96,7 +93,7 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			b = MathHelper.clamp(b, 0, 255);
 			a = MathHelper.clamp(a, 0, 255);
 
-			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
+			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO))) {
 				r = g = b = (r + g + b) / 3;
 			}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 20f951f0f..4afa26708 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -5,6 +5,7 @@ import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -96,11 +97,15 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + pp * 50.0F);
 
-			if (this.mc.currentWorld != null && this.mc.currentWorld.dimension == Dimension.NETHER) {
-				r = 255;
-				g = (int) (110.0F + pp * 64.0F);
-				b = (int) (32.0F + pp * 32.0F);
+			if (this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.NETHER)) {
 				a = (int) (225.0F + pp * 50.0F);
+
+				if (!GameSettings.BIOME_WATER.value) {
+					final float br = 0.3F;
+					r = (int) (255.0F * br);
+					g = (int) ((50.0F + pp * 64.0F) * br);
+					b = (int) ((32.0F + pp * 32.0F) * br);
+				}
 			}
 
 			r = MathHelper.clamp(r, 0, 255);
@@ -108,7 +113,7 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			b = MathHelper.clamp(b, 0, 255);
 			a = MathHelper.clamp(a, 0, 255);
 
-			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.isRetro())) {
+			if (GameSettings.BIOME_WATER.value && !(this.mc.currentWorld != null && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.RETRO))) {
 				r = g = b = (r + g + b) / 3;
 			}
 
diff --git a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
index bfe1b2801..0d935ae3a 100644
--- a/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
+++ b/game/client/src/main/java/net/minecraft/client/world/WorldClient.java
@@ -37,7 +37,6 @@ import org.joml.Vector3fc;
 
 public class WorldClient extends World {
     private final @NotNull Minecraft mc;
-    private int lightningFlicker;
 
     public WorldClient(
         final @NotNull Minecraft mc,
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
index 3dc8201c5..f0209e5ad 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievements.java
@@ -137,10 +137,6 @@ public abstract class Achievements
         new Achievement(NamespaceID.fromPool("minecraft", "sleep_nether"), "sleepNether", Items.BED, ENTER_NETHER)
             .setType(Achievement.TYPE_SPECIAL)
             .registerAchievement();
-//    public static Achievement ENTER_WARRENS =
-//        new Achievement(NamespaceID.getPermanentNamespaceID("minecraft", "enter_warrens"), "enterWarrens", Blocks.BEDROCK, ENTER_NETHER)
-//            .setType(Achievement.TYPE_NORMAL)
-//            .registerAchievement();
     public static Achievement MOST_WANTED =
         new Achievement(NamespaceID.fromPool("minecraft", "most_wanted"), "mostWanted", Items.TOOL_SWORD_GOLD, ENTER_NETHER)
             .setType(Achievement.TYPE_NORMAL)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
index 4571d9d7b..2dffdb031 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
@@ -7,9 +7,13 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -44,6 +48,10 @@ public class BlockLogicIce extends BlockLogicTransparent {
     @Override
 	public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick)
     {
+        if (isRandomTick && rand.nextInt(8) == 0 && world.getWorldType().hasTag(WorldTypeTags.HOT)) {
+            world.setBlockTypeNotify(tilePos, Blocks.FLUID_WATER_STILL);
+        }
+
         if(world.getSavedLightValue(LightLayer.Block, tilePos) > 11 - this.block.lightBlock())
         {
             world.setBlockTypeNotify(tilePos, Blocks.FLUID_WATER_STILL);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index 61f712082..c4d25e101 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -10,6 +10,7 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -85,7 +86,7 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
-        if (!world.getBlockBiome(tilePos).hasSurfaceSnow() && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
+        if (!world.getBlockBiome(tilePos).hasTag(BiomeTags.HAS_SURFACE_SNOW) && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
index 2adfb8081..4a1a2e60f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMud.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -146,7 +147,7 @@ public class BlockLogicMud extends BlockLogic {
 
         // dry out mud
         if (!this.isHardened) {
-            if (isLavaNearby(world, tilePos) || world.dimension == Dimension.NETHER) {
+            if (isLavaNearby(world, tilePos) || world.getWorldType().hasTag(WorldTypeTags.HOT)) {
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
                 for (int l = 0; l < 8; l++) {
                     world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index c1cbb98a1..b3eab3a36 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -24,7 +25,7 @@ public class BlockLogicPumice extends BlockLogic {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
         byte radius = 2;
-        if (this.isWet && (inWater(world, tilePos) || world.dimension.id == Dimension.DRIFT.id)) {
+        if (this.isWet && (inWater(world, tilePos) || world.getWorldType().hasTag(WorldTypeTags.COLD))) {
             world.setBlockTypeNotify(tilePos, Blocks.PUMICE_DRY);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for (int l = 0; l < 8; l++) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
index 5535bbe5d..5b7d27d88 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRubyglassCrop.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
@@ -118,7 +119,7 @@ public class BlockLogicRubyglassCrop extends BlockLogic {
 
     private float getGrowthRate (final @NotNull World world, final @NotNull TilePosc tilePos) {
         float growthRate = 0F;
-        if(world.dimension == Dimension.NETHER) {
+        if(world.getWorldType().hasTag(WorldTypeTags.HOT)) {
             growthRate = 5F;
         }
         else if(isLavaNearby(world, tilePos)) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
index 4880f4825..e839161c1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSponge.java
@@ -9,6 +9,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -24,7 +25,7 @@ public class BlockLogicSponge extends BlockLogic {
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
-        if ((world.dimension == Dimension.NETHER || inHot(world, tilePos)) && this.isWet) {
+        if ((world.getWorldType().hasTag(WorldTypeTags.HOT) || inHot(world, tilePos)) && this.isWet) {
             world.setBlockTypeNotify(tilePos, Blocks.SPONGE_DRY);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for (int l = 0; l < 8; l++) {
@@ -39,7 +40,6 @@ public class BlockLogicSponge extends BlockLogic {
                     for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
                         if (world.getBlockType(queryPos).hasTag(BlockTags.IS_WATER)) {
                             world.setBlockTypeNotify(queryPos, Blocks.AIR);
-
                         }
                     }
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
index 47d0f217d..c37bb89a0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidLava.java
@@ -6,6 +6,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -41,7 +42,7 @@ public class FluidLava
         if (encountered == Materials.WATER) {
             final int data = world.getBlockData(tilePos) & 0x0F;
 
-            if (world.dimension == Dimension.NETHER) {
+            if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
                 if (data == 0) {
                     world.setBlockTypeNotify(tilePos, Blocks.MAGMA);
                 } else {
@@ -106,7 +107,7 @@ public class FluidLava
 
     @Override
     public byte getFlowDecayMod(final @NotNull BlockLogicFluid logicFluid, final @NotNull World world, final @NotNull TilePosc tilePos) {
-        if (world.dimension == Dimension.NETHER) {
+        if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
             return 1;
         } else {
             return 2;
diff --git a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
index dc72e0456..e9484a1fa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/FluidWater.java
@@ -8,6 +8,7 @@ import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -29,7 +30,7 @@ public class FluidWater
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (float) tilePos.x() + 0.5F, (float) tilePos.y() + 0.5F, (float) tilePos.z() + 0.5F, "liquid.water", rand.nextFloat() * 0.25F + 0.75F, rand.nextFloat() * 1.0F + 0.5F);
             }
         }
-        if (world.dimension == Dimension.NETHER && isTop && data == 0 && rand.nextInt(4) == 0) {
+        if (world.getWorldType().hasTag(WorldTypeTags.NETHER) && isTop && data == 0 && rand.nextInt(4) == 0) {
             world.spawnParticle("smoke", tilePos.x() + Math.random(), tilePos.y() + (14f / 16f), tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 1);
         }
 
@@ -46,7 +47,7 @@ public class FluidWater
         if (encountered == Materials.LAVA) {
             final int data = world.getBlockData(tilePos) & 0x0F;
             if (data == 0) {
-                if (world.dimension == Dimension.NETHER) {
+                if (world.getWorldType().hasTag(WorldTypeTags.NETHER)) {
                     world.setBlockTypeNotify(tilePos, Blocks.NETHERRACK);
                 } else {
                     world.setBlockTypeNotify(tilePos, Blocks.COBBLE_LIMESTONE);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 09103a1ed..0276d2e48 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -31,6 +31,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3dc;
@@ -340,7 +341,7 @@ public abstract class Entity
     }
 
     public void waterHurt() {
-        if (this.world.dimension == Dimension.NETHER && !(this.vehicle instanceof EntityBoat)) {
+        if (this.world.getWorldType().hasTag(WorldTypeTags.HOT) && !(this.vehicle instanceof EntityBoat)) {
             hurt(null, 1, DamageType.FIRE);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index d38f53965..34ef4b625 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -443,7 +443,7 @@ public class MobFireflyCluster extends MobFlying
             Biomes.NETHER_SULFUR_POOLS,
             Biomes.NETHER_VOLCANIC_ISLANDS,
             Biomes.NETHER_CRYSTAL_FOREST,
-            Biomes.NETHER_CRYSTAL_FIELD,
+            Biomes.NETHER_CRYSTAL_PLAINS,
             Biomes.NETHER_OLD_WORLD
         },
             new float[]{1f, 0.25f, 0.25f}));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index 7169b1449..16f6e6112 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -57,6 +57,7 @@ import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.provider.ChunkProvider;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -248,13 +249,8 @@ public abstract class Player
 
     @Override
     public void tick() {
-        if (this.world.dimension == Dimension.NETHER) {
+        if (this.world.getDimension() == Dimension.NETHER) {
             addStat(Achievements.ENTER_NETHER, 1);
-            /*if (y >=128) {
-                addStat(Achievements.ENTER_NETHER, 1);
-            }  else {
-                addStat(Achievements.ENTER_WARRENS, 1);
-            }*/
         }
 
         this.xdO = this.xd;
@@ -1353,7 +1349,7 @@ public abstract class Player
             int j = java.lang.Math.round(MathHelper.sqrt(d * d + d2 * d2) * 100F);
             if (j > 0) {
                 addStat(StatList.distanceSwumStat, j);
-                if (this.dimension == Dimension.NETHER.id) {
+                if (this.world.getDimension() == Dimension.NETHER) {
                     addStat(Achievements.SWIM_NETHER, 1);
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 0d632252a..ed98f02db 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -10,7 +10,10 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -47,7 +50,7 @@ public class ItemBucket extends Item {
         }
 
         Block<?> block = world.getBlockType(rayCastPos);
-        if (block != null && !block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
+        if (!block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
             Side side = hitTile.side;
             rayCastPos.x += side.getOffsetX();
             rayCastPos.y += side.getOffsetY();
@@ -62,9 +65,10 @@ public class ItemBucket extends Item {
             if (this.blockToPlace == Blocks.FLUID_WATER_FLOWING) {
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.splash", 0.5f, 1.0f);
             }
-            player.swingItem();
-            world.getBlockType(rayCastPos).dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
             world.setBlockTypeNotify(rayCastPos, this.blockToPlace);
+            world.getBlockType(rayCastPos).dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
+
+            player.swingItem();
             if (player.getGamemode().hasBlockConsumption()) {
                 return new ItemStack(Items.BUCKET);
             }
@@ -83,6 +87,8 @@ public class ItemBucket extends Item {
         Block<?> b = world.getBlockType(posAhead);
         if (b.hasTag(BlockTags.PLACE_OVERWRITES) || b.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
             world.setBlockTypeNotify(posAhead, this.blockToPlace);
+            world.getBlockType(posAhead).dropWithCause(world, EnumDropCause.WORLD, posAhead, world.getBlockData(posAhead), null, null);
+
             selfStack.itemID = Items.BUCKET.id;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 79e60efb6..6a748984f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -20,6 +20,7 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.type.WorldTypes;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -63,7 +64,7 @@ public class ItemDye extends Item {
                 if (!world.isClientSide) {
                     if (world.getBlockType(blockPos.up(queryPos)).lightBlock() <= 2) {
                         @NotNull Block<?> grass = Blocks.GRASS;
-                        if (world.getDimensionData().getWorldType().isRetro()) {
+                        if (world.getDimensionData().getWorldType().hasTag(WorldTypeTags.RETRO)) {
                             grass = Blocks.GRASS_RETRO;
                         }
                         world.setBlockTypeNotify(blockPos, grass);
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index 4b8e0a4b8..ad07a83ce 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -11,6 +11,7 @@ import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.season.SeasonManager;
+import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.weather.WeatherManager;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -29,6 +30,16 @@ public class BlocksContainer implements MutableWorldSource {
         this.world = world;
     }
 
+    @Override
+    public @NotNull Dimension getDimension() {
+        return this.world.getDimension();
+    }
+
+    @Override
+    public @NotNull WorldType getWorldType() {
+        return this.world.getWorldType();
+    }
+
     @Override
     public int getHeightBlocks() {
         return this.world.getHeightBlocks();
@@ -224,11 +235,6 @@ public class BlocksContainer implements MutableWorldSource {
         return this.world.getSavedLightIndex(tilePos);
     }
 
-    @Override
-    public boolean isRetro() {
-        return this.world.isRetro();
-    }
-
     public static class BlockEntry {
         public @NotNull Block<?> block;
         public int data;
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 63af916b6..c93a4b9e0 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -259,6 +259,13 @@ public abstract class World implements MutableWorldSource {
         return this.dimensionData.getDimensionSettings().getNodeValueOr(node, or);
     }
 
+    @Override
+    public @NotNull Dimension getDimension() {
+        return this.dimension;
+    }
+
+
+
     public abstract void setLightningFlicker(final int flicker);
 
     public <T> T getGameRuleValue(final GameRule<T> gameRule) {
@@ -895,11 +902,6 @@ public abstract class World implements MutableWorldSource {
         }
     }
 
-    @Override
-    public boolean isRetro() {
-        return this.getWorldType().isRetro();
-    }
-
     @Override
     public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value) {
         if (tilePos.inBounds(this) && this.isBlockLoaded(tilePos)) {
@@ -2795,6 +2797,7 @@ public abstract class World implements MutableWorldSource {
         this.playBlockEvent(player, new TilePos(x, y, z), id, data);
     }
 
+    @Override
     public @NotNull WorldType getWorldType() {
         return this.dimensionData.getWorldType();
     }
